Bugzilla (bugzilla.redhat.com) will be under maintenance for infrastructure upgrades and will not be unavailable on July 31st between 12:30 AM - 05:30 AM UTC. We appreciate your understanding and patience. You can follow status.redhat.com for details.
Bug 1807365 - Review Request: nuspell - Free and open source C++ spell checking library
Summary: Review Request: nuspell - Free and open source C++ spell checking library
Keywords:
Status: POST
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1820723 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-02-26 08:03 UTC by vishalvvr
Modified: 2021-02-02 15:08 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug
zebob.m: fedora-review+


Attachments (Terms of Use)

Description vishalvvr 2020-02-26 08:03:34 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/vishalvvr/nuspell/fedora-31-x86_64/01251964-nuspell/nuspell.spec

SRPM URL: https://download.copr.fedorainfracloud.org/results/vishalvvr/nuspell/fedora-31-x86_64/01251964-nuspell/nuspell-3.0.0-1.fc31.src.rpm

Description: Nuspell is a free and open source spell checker library and command-line program designed for languages with rich morphology and complex word compounding. Nuspell is a pure C++ re-implementation of Hunspell.

Fedora Account System Username: vishalvvr

Comment 2 Artur Frenszek-Iwicki 2020-02-29 13:55:01 UTC
>Source0:	https://github.com/nuspell/nuspell/archive/v3.0.0.tar.gz
You can use %{version} as part of the URL so you don't have to edit it manually every time there's a new version.

>BuildRequires:	gcc
>BuildRequires:	cmake
>BuildRequires:	boost-locale
I'd recommend ordering these aplhabetically.

>%description
>Nuspell is a free and open source spell checker library and \
>command-line program designed for languages with rich morphology and \
>complex word compounding. Nuspell is a pure C++ re-implementation of Hunspell.
Do not escape the newlines in description - this creates one, single, long line. Each line of the description should be no longer than 80 characters.
https://docs.fedoraproject.org/en-US/packaging-guidelines/#_summary_and_description

>cmake . -DBUILD_SHARED_LIBS=1 -DCMAKE_BUILD_TYPE=Release \
>	 -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Debug
1. Use %{_prefix} instead of writing "/usr" outright.
2. Why is CMAKE_BUILD_TYPE specified twice?

>%files
>%{_mandir}/man1/%{name}.1.gz
Do not assume that man pages will be gzipped. Use a wildcard that can match both compressed and non-compressed pages.
https://docs.fedoraproject.org/en-US/packaging-guidelines/#_manpages

Comment 4 Robert-André Mauchin 🐧 2020-03-22 16:58:52 UTC
 - Use a better name for your archive:

Source0:	https://github.com/%{name}/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz


 - Use the %cmake macro:

%cmake . -DBUILD_SHARED_LIBS=1 -DCMAKE_BUILD_TYPE=Debug \
	-DCMAKE_INSTALL_PREFIX=%{_prefix}

 - make %{?_smp_mflags} → %make_build

 - %ldconfig_scriptlets is not needed anymore

 - In order to avoid unintentional soname bump, we recommend not globbing the major soname version, be more specific instead:

%{_libdir}/*.so.3*

Comment 6 Robert-André Mauchin 🐧 2020-03-26 14:34:19 UTC
 - You must install the license files with %license in %files

%license COPYING COPYING.LESSER

 - You should install the docs with %doc in %files:

%doc AUTHORS CHANGELOG.md README.md




Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* GNU Lesser General
     Public License (v3)", "Mozilla Public License 1.1 GNU General Public
     License (v2 or later) or GNU Lesser General Public License (v2.1 or
     later)", "GNU Lesser General Public License (v3 or later)", "Mozilla
     Public License GNU Lesser General Public License (v2.1)", "*No
     copyright* Mozilla Public License 1.1 GNU General Public License (v2
     or later) or GNU Lesser General Public License (v2.1 or later)", "GPL
     (v2 or later)", "GNU Lesser General Public License (v2.1)". 489 files
     have unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/nuspell/review-nuspell/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nuspell-3.0.0-4.fc33.x86_64.rpm
          nuspell-devel-3.0.0-4.fc33.x86_64.rpm
          nuspell-debuginfo-3.0.0-4.fc33.x86_64.rpm
          nuspell-debugsource-3.0.0-4.fc33.x86_64.rpm
          nuspell-3.0.0-4.fc33.src.rpm
5 packages and 0 specfiles checked; 0 errors, 0 warnings.

Comment 8 Robert-André Mauchin 🐧 2020-04-03 20:08:48 UTC
LGTM, package approved.

Comment 9 Igor Raits 2020-04-05 09:51:29 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/nuspell

Comment 10 Pander 2020-04-20 14:55:00 UTC
*** Bug 1820723 has been marked as a duplicate of this bug. ***

Comment 11 Pander 2020-04-20 15:08:44 UTC
Thanks for packaging, great job!

I'm one of the developers. On April 7th, we have releases version 3.1, please see https://github.com/nuspell/nuspell/releases/tag/v3.1.0 and update the package.

For your spec file, please make the following changes:

1) add near the top:
"Requires:  hunspell-en-US"

2) change
"Summary:	Free and open source C++ spell checking library"
into"
"Summary:	Free and open source C++ spell checking library and command-line tool"

3) change

"Nuspell is a free and open source spell checker library.
It is designed for languages with rich morphology and complex word compounding.
Nuspell is a pure C++ re-implementation of Hunspell."
into
"Nuspell is a free and open source spell checker library and command-line tool.
It is designed for languages with rich morphology and complex word compounding.
Nuspell is a pure C++ implementation supporting Hunspell dictionaries."

4) change
"%license COPYING COPYING.LESSER"
into
"%license COPYING.LESSER"
because the file COPYING in only related to legacy code which not being used in the build.

Some questions from me:

5) Why do you use "-DCMAKE_BUILD_TYPE=Debug"?

6) If you omit "-DBUILD_TESTING=OFF" then you have to add Catch2 as a build dependency

See also our Fedora package for 3.1.0 at https://github.com/nuspell/misc-nuspell/blob/master/packaging/rpm/nuspell.spec or contact me if you have any questions.

Comment 12 Pander 2020-04-21 09:08:12 UTC
Please ignore point 4) in my previous message, that is good as it is.

Comment 13 vishalvvr 2020-05-15 03:15:14 UTC
(In reply to Pander from comment #12)
> Please ignore point 4) in my previous message, that is good as it is.

SPEC URL: https://download.copr.fedorainfracloud.org/results/vishalvvr/nuspell/fedora-31-x86_64/01351241-nuspell/nuspell.spec

SRPM URL: https://download.copr.fedorainfracloud.org/results/vishalvvr/nuspell/fedora-31-x86_64/01351241-nuspell/nuspell-3.1.0-1.fc31.src.rpm

Could you please verify the changes, Thanks

Comment 14 Pander 2020-05-15 08:45:08 UTC
Thanks for the changes. They were good, until we changed the description recently. Sorry for that. If you can, please change

Summary:
C++ spelling checking library and command-line tool

Requires: has one tab character too many after it

%description
Nuspell is a fast and safe spelling checker software program. It is designed
for languages with rich morphology and complex word compounding. Nuspell is
written in modern C++ and it supports Hunspell dictionaries.

%package devel
Summary:	Development tools for %{name}

(make sure there is no whitespace at the end of the line for Summary)


The latest release is here:
https://github.com/nuspell/nuspell/releases/tag/v3.1.1

Please upgrade the spec file for this too. Thanks.

Comment 15 Pander 2020-05-20 07:41:08 UTC
Sorry, one more minor fix. Thanks for updating it.

Summary:
Fast and safe spellchecking C++ library and command-line tool

Comment 16 Pander 2020-07-08 09:35:49 UTC
Meanwhile, version 3.1.2 has been released. Please upgrade FRP to use that version. Thanks.

Comment 17 Pander 2020-11-17 10:59:25 UTC
Version 4.0.1 has been released. Please drop -DBUILD_SHARED_LIBS=1 as that is default. Also replace build dependency on ronn with one on pandoc. See also https://github.com/nuspell/nuspell/issues/94 Please let me know when an update of the spec file has been made, so I can double check it.

Comment 18 vishal vijayraghavan 2021-02-02 04:28:47 UTC
Nuspell package updated[1] to latest release 4.2.0.
This update is build currently for rawhide only, please review and suggest updates if any.
Thanks :)

[1] https://src.fedoraproject.org/rpms/nuspell/blob/master/f/nuspell.spec

Comment 19 Dimitrij Mijoski 2021-02-02 15:08:59 UTC
(In reply to vishal vijayraghavan from comment #18)
> Nuspell package updated[1] to latest release 4.2.0.
> This update is build currently for rawhide only, please review and suggest
> updates if any.
> Thanks :)
> 
> [1] https://src.fedoraproject.org/rpms/nuspell/blob/master/f/nuspell.spec

First I would like to thank you for maintaining this package. I'll suggest updates:

Line 4 should be changed from:
Summary:	C++ spelling checking library and command-line tool
to
Summary:	C++ spellchecking library and command-line tool

The following lines are most likely not needed, thus they should be deleted:

 8: BuildRequires:	boost-locale
 9: BuildRequires:	clang
11: BuildRequires:	gcc
13: BuildRequires:	git
15: BuildRequires:	rdkit-devel

Boost used to be required but now it is not.
Clang is not needed, gcc-c++ is already ok.
gcc-c++ also implies gcc, no need to specify gcc when gcc-c++ is there.
Git is not needed.
I don't know what rdkit is. Giving a quick web-search, I can say it has no relation to this package.

Line 38 and 39 can be simplified from:

38: %cmake -DCMAKE_BUILD_TYPE=Release \
39:	-DCMAKE_INSTALL_PREFIX=%{_prefix}

to just:

%cmake -DCMAKE_BUILD_TYPE=Release

Install prefix is automatically specified by the %cmake thing.


Note You need to log in before you can comment on or make changes to this bug.